# Functionality

This Extension, with the use of Multiplug.Ext.Network.Sockets, allows you to connect to Upstream and Downstream electronics production equipment that are also capable of communicating using the IPC-HERMES-9852 messaging standard (https://www.the-hermes-standard.info).

The modes of operation are Pass-Through and SMEMA Gateway.

* The Pass-Through mode allows the creation of a Hermes man-in-the-middle to capture message data which will include PCB (Printed Circuit Board) information.

* The SMEMA Gateway mode (IPC-SMEMA-9851) requires an additional hardware Extension to interface with the SMEMA I/O, eg [MultiPlug.Ext.RasPi.GPIO](https://www.nuget.org/packages/MultiPlug.Ext.RasPi.GPIO/) or [MultiPlug.Ext.Brainboxes](https://www.nuget.org/packages/MultiPlug.Ext.Brainboxes/) . This mode allows SMEMA equipment to be upgraded and prevents PCB data from being lost as a PCB (printed circuit board) moves along an assembly line.

# Setup

1. Within [MultiPlug.Ext.Network.Sockets](https://www.nuget.org/packages/MultiPlug.Ext.Network.Sockets/), create a Client Socket for the Upstream machine and use its IP address and the default port 50101.
2. Within [MultiPlug.Ext.Network.Sockets](https://www.nuget.org/packages/MultiPlug.Ext.Network.Sockets/), create a Socket Endpoint for the Downstream machine and use the default port 50101.
3. Within Multiplug.Ext.Network.Sockets Client Socket, subscribe to the Hermes Upstream XML message send event, of MultiPlug.Ext.Hermes.
4. Within Multiplug.Ext.Network.Sockets Socket Endpoint, subscribe to Herme Downstream XML message send event, of MultiPlug.Ext.Hermes.
5. Within MultiPlug.Ext.Hermes Upstream settings, subscribe to the Client Socket read event, of Multiplug.Ext.Network.Sockets.
6. Within MultiPlug.Ext.Hermes Downstream settings, subscribe to the Socket Endpoint read event, of Multiplug.Ext.Network.Sockets.
7. Simular event mappings will need to be created for SMEMA events of [MultiPlug.Ext.RasPi.GPIO](https://www.nuget.org/packages/MultiPlug.Ext.RasPi.GPIO/) or [MultiPlug.Ext.Brainboxes](https://www.nuget.org/packages/MultiPlug.Ext.Brainboxes/).
7. Click Deploy within MultiPlug and the Event connections will be made.

For more information please view the [Extension's Wiki](https://github.com/Industry4/MultiPlug.Ext.Hermes/wiki).

## Purchase a Software License

This Extension works under a 60 minute evaluation. To purchase a licence visit: https://www.smartfactorydirect.com/multiplugexthermes-software-license

## MultiPlug Edge Computing Platform

This Extension runs on the MultiPlug Edge Computing Platform. For more information visit: https://www.multiplug.app To purchase a licence visit: https://www.smartfactorydirect.com/multiplug-software-license
